%def_disable static
%def_enable utils
%def_disable check

Name: jpeg-mmx
Version: 0.1.5
Release: alt3

Summary: JPEG image library optimized for ix86 architectures
Group: System/Libraries
License: distributable
URL: http://mjpeg.sourceforge.net/

Source: http://prdownloads.sourceforge.net/mjpeg/%name-%version.tar.gz
Source1: testimages.tar.bz2

Patch: %name-0.1.5-alt-shared-build.patch
Patch1: %name-0.1.5-alt-pic-register-use.patch
Patch2: %name-0.1.5-alt-build.patch
Patch3: %name-0.1.5-alt-test.patch
# libjpeg package patches
Patch4: libjpeg-6b-rh-c++.patch
Patch5: libjpeg-6b-rh-arm.patch
Patch6: libjpeg-6b-up-crop.patch
Patch7: libjpeg-6b-deb-crop_man.patch
Patch8: libjpeg-6b-deb-rdppm.patch
Patch9: libjpeg-6b-alt-rdjpgcom-i18n.patch

Patch20: %name-0.1.5-alt-gcc3.4.patch

%if_enabled static
BuildPreReq: glibc-devel-static
%endif
BuildRequires: nasm

%description
This is a variant of libjpeg, a library for manipulating
JPEG image format files, making use of MMX and SIMD instructions of the
IA32 (Intel x86) processor family.

%package -n lib%name
Summary: Shared %name library
Group: System/Libraries

%description -n lib%name
The lib%name package contains a shared library of functions for loading,
manipulating and saving JPEG format image files using mmx optimization.

%package  -n lib%name-devel
Summary: Development files for jpeg-mmx
Group: Development/C
Requires: lib%name = %version-%release

%description -n lib%name-devel
Headers and other files needed to develop applications using the %name library.

%if_enabled static
%package -n lib%name-devel-static
Summary: Static build of jpeg-mmx
Group: Development/C
Requires: lib%name-devel = %version-%release

%description -n lib%name-devel-static
Static build of the %name library.
%endif	# enabled static

%if_enabled utils
%package utils
Summary: Programs for manipulating JPEG format image files
Group: Graphics
Requires: lib%name = %version-%release

%description utils
%name client programs include cjpeg, djpeg, jpegtran, rdjpgcom and wrjpgcom.
Cjpeg compresses an image file into JPEG format. 
Djpeg decompresses a JPEG file into a regular image file.
Jpegtran can perform various useful transformations on JPEG files.
Rdjpgcom displays any text comments included in a JPEG file.
Wrjpgcom inserts text comments into a JPEG file.
%endif	# enabled utils

%set_verify_elf_method textrel=relaxed

%prep
%setup -q -a1
%patch -p1 -b .orig-shared
%patch1 -p1 -b .orig-pic
%patch2 -p1 -b .orig-build
%patch3 -p1 -b .orig-test 
%patch4 -p1 -b .orig-c++
%patch5 -p1 -b .orig-arm
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1

%patch20 -p1 -b gcc34

%build
%define _optlevel 6
%configure \
	    --enable-shared \
    	    %{subst_enable static} \
	    --disable-rpath

%make_build
%{?!__buildreqs:%{?!_without_check:%{?!_disable_check:LD_LIBRARY_PATH=$PWD make test}}}

%install
%make_install DESTDIR=%buildroot install

%post -n lib%name -p %post_ldconfig
%postun -n lib%name -p %postun_ldconfig

%files -n lib%name
%_libdir/*.so.*

%files -n lib%name-devel
%_libdir/*.so
%_includedir/*
%doc README *.doc example.c

%if_enabled static
%files -n lib%name-devel-static
%_libdir/*.a
%endif

%if_enabled utils
%files utils
%_bindir/*
%_man1dir/*
%endif

%changelog
* Sat Jan 22 2005 Yuri N. Sedunov <aris@altlinux.ru> 0.1.5-alt3
- applied some patches from libjpeg package.
- allow tests.

* Sat Jan 22 2005 Mikhail Zabaluev <mhz@altlinux.ru> 0.1.5-alt2
- Updated Patch1 for gcc 3.4
- New patch for correct use of constants that were otherwise optimized away
  by gcc 3.4 [Patch20].

* Wed Feb 11 2004 Mikhail Zabaluev <mhz@altlinux.ru> 0.1.5-alt1
- Initial build.
- Disabled utils package and static library by default
- Make buildable with --enable-shared [Patch0]
- Adapt the inline assembly blocks to avoid use of the ebx register
  which is reserved for PIC by gcc 3.3 [Patch1]
- (aris) [Patch2]
    use %make_install.
    install utils and its manpages suffixed by "-mmx" to avoid conflict
    with jpeg-utils package.
    install more headers and move to /usr/include/jpeg-mmx to avoid
    conflict with jpeg-devel package.
